-- Begonnen
-- - Erweitern mit Dialog für Preise mit Lagerbeständen aus allen Lagern und Produktionen
--  - Da Lager zu nah zusammen stehen die Silos mal neu plazieren mit mehr abstand. Mehr als 50 m sind notwendig.
--  - Einfach Verkaufen, neu setzen und alte Lagerbestände wieder einfügen per items.xml oder ingame umziehen

-- Was fehlt noch?
-- - Speichern der Werte als Einstellungen
-- - Einstellungen in GC Menü mit gesamtliste zum scollen
-- - Per Taste ein und ausblenden können

-- - Bei Giants nachfragen, wie die HUD Klassen verwendet werden sollen
--   - https://gdn.giants-software.com/thread.php?categoryId=3&threadId=9326
-- - Bei GC nachfragen, wo eine Doku ist die man auch verwenden kann, habe jetzt alles aus anderen Mods rausgelesen
--   - https://ls-modcompany.com/forum/thread/9203-wo-finde-ich-eine-vollst%C3%A4ndige-dokumentation-und-beispiele/


GC_ProductionInfoHud = {};
GC_ProductionInfoHud._mt = Class(GC_ProductionInfoHud);
InitObjectClass(GC_ProductionInfoHud, "GC_ProductionInfoHud");

function GC_ProductionInfoHud:initGlobalCompany(customEnvironment, baseDirectory, xmlFile)
	if (g_company == nil) or (GC_ProductionInfoHud.isInitiated ~= nil) then
		return;
	end

	GC_ProductionInfoHud.debugIndex = g_company.debug:registerScriptName("GC_ProductionInfoHud");
	GC_ProductionInfoHud.modName = customEnvironment;
	GC_ProductionInfoHud.baseDirectory = baseDirectory;
	GC_ProductionInfoHud.isInitiated = true;
    GC_ProductionInfoHud.sellPriceData = {};
	g_company.ProductionInfoHud = GC_ProductionInfoHud;

	g_company.addInit(GC_ProductionInfoHud, GC_ProductionInfoHud.init);

    --print("g_currentMission : ");
    --DebugUtil.printTableRecursively(g_currentMission,"_",0,2)

    -- einstellungen hier defineren und später beim laden der cfg ersetzen
    -- hier eingestellt werte werden für neue cfgs als default gespeichert
    GC_ProductionInfoHud.settings = {};
    GC_ProductionInfoHud.settings["display"] = {};
    GC_ProductionInfoHud.settings["display"]["textSize"] = 0.011;
    GC_ProductionInfoHud.settings["display"]["showType"] = "ALL"

    -- config speichern, wenn savegame gespeichert wird
    FSBaseMission.saveSavegame = Utils.appendedFunction(FSBaseMission.saveSavegame, GC_ProductionInfoHud.saveCfg)

    -- ActionEvents registrieren
    FSBaseMission.registerActionEvents = Utils.appendedFunction(FSBaseMission.registerActionEvents, GC_ProductionInfoHud.registerActionEvents)
end

function GC_ProductionInfoHud:registerActionEvents()
	if GC_ProductionInfoHud.isClient then
		_, GC_ProductionInfoHud.eventIdToggle = g_inputBinding:registerActionEvent(InputAction.TOGGLE_GUI, GC_ProductionInfoHud, GC_ProductionInfoHud.ToggleGui, false, true, false, true, -1, true)
	end
end

function GC_ProductionInfoHud:ToggleGui()
    if GC_ProductionInfoHud.settings["display"]["showType"] == "ALL" then 
        GC_ProductionInfoHud.settings["display"]["showType"] = "PRODUCTION"
    elseif GC_ProductionInfoHud.settings["display"]["showType"] == "PRODUCTION" then 
        GC_ProductionInfoHud.settings["display"]["showType"] = "SELLPRICE"
    elseif GC_ProductionInfoHud.settings["display"]["showType"] == "SELLPRICE" then 
        GC_ProductionInfoHud.settings["display"]["showType"] = "NONE"
    else 
        GC_ProductionInfoHud.settings["display"]["showType"] = "ALL"
    end
print("showType:" .. GC_ProductionInfoHud.settings["display"]["showType"]);
end

function GC_ProductionInfoHud:loadCfg()
    print("GC_ProductionInfoHud:loadCfg()");
	if g_currentMission.missionInfo.savegameDirectory ~= nil then
		local file = g_currentMission.missionInfo.savegameDirectory.. "/ProductionInfoHudSettings.xml"
        if fileExists(file) then
            print("GC_ProductionInfoHud: Settings loaded from file");
            local XML = loadXMLFile("ProductionInfoHudSettings_XML", file, "ProductionInfoHudSettings")

            local xmlTag = ("ProductionInfoHudSettings.display.textSize(%d)"):format(0); 
            local value = getXMLFloat(XML, xmlTag.. "#float");
            if value ~= nil then GC_ProductionInfoHud.settings["display"]["textSize"] = value;end;
            
            xmlTag = ("ProductionInfoHudSettings.display.showType(%d)"):format(0); 
            value = getXMLString(XML, xmlTag.. "#string");
            if value ~= nil then GC_ProductionInfoHud.settings["display"]["showType"] = value;end;
            
            saveXMLFile(XML)
        else
            print("GC_ProductionInfoHud: No settings file found");
        end
	end
end

function GC_ProductionInfoHud:saveCfg()
	if g_currentMission.missionInfo.savegameDirectory ~= nil then
		local file = g_currentMission.missionInfo.savegameDirectory.. "/ProductionInfoHudSettings.xml"
		local XML = createXMLFile("ProductionInfoHudSettings_XML", file, "ProductionInfoHudSettings")

		local xmlTag = ("ProductionInfoHudSettings.display.textSize(%d)"):format(0);
		setXMLFloat(XML, xmlTag.."#float", GC_ProductionInfoHud.settings["display"]["textSize"])

		local xmlTag = ("ProductionInfoHudSettings.display.showType(%d)"):format(0);
		setXMLString(XML, xmlTag.."#string", GC_ProductionInfoHud.settings["display"]["showType"])
		
		saveXMLFile(XML)

--    print("FSBaseMission : ");
--    print_r(FSBaseMission);

	end
end

function GC_ProductionInfoHud:init()
	GC_ProductionInfoHud.isServer = g_server ~= nil;
	GC_ProductionInfoHud.isClient = g_dedicatedServerInfo == nil;
	GC_ProductionInfoHud.isMultiplayer = g_currentMission.missionDynamicInfo.isMultiplayer;
	GC_ProductionInfoHud.FirstRun = true;
	GC_ProductionInfoHud.overlay = Overlay:new("dataS2/menu/hud/hud_elements_2160p.png", 0, 0, 0, 0);

	g_company.addUpdateable(GC_ProductionInfoHud, GC_ProductionInfoHud.update);	

    GC_ProductionInfoHud:loadCfg();

    -- ein mal direkt aufrufen, damit beim start schon verfügbar
    GC_ProductionInfoHud.registerActionEvents();

-- for debug
----    GC_ProductionInfoHud.refreshOutputTable();
--    print("outputTable : ");
--    print_r(g_currentMission.storageSystem.loadingStations);
end;

function GC_ProductionInfoHud:update()
    GC_ProductionInfoHud:refreshOutputTable();
    GC_ProductionInfoHud:refreshSellPriceData();
    GC_ProductionInfoHud:drawHud();
end;

function GC_ProductionInfoHud:refreshSellPriceData()
    if FS19_SellPriceTrigger == nil then return end;
    if FS19_SellPriceTrigger.SellPriceTrigger == nil then return end;
    if FS19_SellPriceTrigger.SellPriceTrigger.triggers == nil then return end;

    local prices = {};

    -- liste füllen mit den types, die gerade einen guten preis haben
	for fillType,trigger in pairs(FS19_SellPriceTrigger.SellPriceTrigger.triggers) do
        if trigger.over == true then
            prices[fillType] = {info=trigger,storages={},total=0}
        end
	end

    -- für alle mit gutm preis aus den produktionen die Lagerbestände sammeln
    for i, globalFactory in pairs (g_company.loadedFactories) do
        for a, product in pairs (globalFactory.outputProducts) do
            if prices[product.fillTypeIndex] ~= nil then
                prices[product.fillTypeIndex].storages[globalFactory.indexName] = {fillLevel=product.fillLevel}
                prices[product.fillTypeIndex].total = prices[product.fillTypeIndex].total + product.fillLevel;
            end
        end
    end

    -- storageSystem benutzen. Storages splitten sich auf, wenn diese zu nah zusammen stehen, aber das ist in LS so und ich kann das nicht ändern.
    local storages = g_currentMission.storageSystem:getStorages();
    for i, storage in pairs (storages) do
        local storageName = "";
        for j, unloadingStation in pairs (storage.unloadingStations) do
            if storageName ~= "" then storageName = storageName .. "-" end;
            storageName = storageName .. unloadingStation.stationName;
        end

        for fillType, fillLevel in pairs(storage.fillLevels) do
            if prices[fillType] ~= nil then
                if prices[fillType].storages[storageName] ~= nill then
                    prices[fillType].storages[storageName].fillLevel=prices[fillType].storages[storageName].fillLevel + fillLevel;
                else
                    prices[fillType].storages[storageName] = {fillLevel=fillLevel}
                end
                prices[fillType].total = prices[fillType].total + fillLevel;
            end
        end
        
    end

    -- List für Anzeige erstellen
    local outputTable = {};
    for a, b in pairs (prices) do
        if b.total >= 100000 then
            outputTable[a] = b;
        end
    end

    GC_ProductionInfoHud.sellPriceData = outputTable;
end;

function GC_ProductionInfoHud:drawHud()

-- try to use the y below the normal HUD
--if g_currentMission.hud ~= nil and g_currentMission.hud.vehicleSchema ~= nil and g_currentMission.hud.vehicleSchema.overlay ~= nil then 
--    local test = Utils.getNoNil(g_currentMission.hud.inputHelp.overlay.x);
--    print("g_currentMission.hud.inputHelp.overlay.x: "..test);
--    local test2 = Utils.getNoNil(g_currentMission.hud.inputHelp.overlay.y);
--    print("g_currentMission.hud.inputHelp.overlay.y: "..test2);
--    print("g_currentMission.hud.inputHelp.overlay.visible: ");
--    print(g_currentMission.hud.inputHelp.overlay.visible);
--    --print("g_currentMission.hud.isMenuVisible : "..g_currentMission.hud.isMenuVisible);
--end

    local posX = 0.013;
    local spaceY = 0.02;
    local posYStart = 0.90;
    local textSize = GC_ProductionInfoHud.settings["display"]["textSize"];
    local lineCount = 0;
    local maxLines = 10;
    local totalTextHeigh = 0;
    local maxTextWidth = 0;
    local additionalCounter = 0;

    -- move under Help Dialog, when help visible
    if (g_currentMission.hud.inputHelp.overlay.visible == true) then
        posX = g_currentMission.hud.inputHelp.overlay.x;
        posYStart = g_currentMission.hud.inputHelp.overlay.y - spaceY;
    end

    local posY = posYStart;

    if GC_ProductionInfoHud.settings["display"]["showType"] == "ALL" or string.find(GC_ProductionInfoHud.settings["display"]["showType"], "PRODUCTION") then 
        for a, outputItem in pairs (GC_ProductionInfoHud.outputTable) do
            if (outputItem.HoursLeft <= 72) then
                if (outputItem.HoursLeft <= 0) then
                    -- ausgabe im Log für Debug
                    -- print(outputItem.Fabrik .. " braucht " .. outputItem.NeedsItem .. ". Platz für " .. math.floor(outputItem.NeedsAmount));
                    if (lineCount < maxLines) then
                        lineCount = lineCount+1;
                        posY = posY - textSize;
                        local textLine = (outputItem.Fabrik .. " | " .. outputItem.NeedsItem .. " | " .. math.floor(outputItem.NeedsAmount));
                        setTextColor(1,0.3,0,1);								
                        setTextBold(true);
                        totalTextHeigh = totalTextHeigh + getTextHeight(textSize, textLine)
                        local textWidth = getTextWidth(textSize, textLine);
                        if (textWidth > maxTextWidth) then maxTextWidth = textWidth; end
                        renderText(posX,posY,textSize,textLine);
                        --renderText(posX + getTextWidth(textSize, textLine),posY,textSize, "Test");
                    else
                       additionalCounter = additionalCounter + 1;
                    end
                else
                    local days = math.floor(outputItem.HoursLeft/24);
                    local hoursLeft = outputItem.HoursLeft-(days*24);
                    local hours = math.floor(hoursLeft);
                    local hoursLeft = hoursLeft-hours;
                    local minutes = math.floor(hoursLeft * 60);
                    if(minutes <= 9) then minutes = "0" .. minutes end;
                    local timeString = "";
                    if (days ~= 0) then 
                        timeString = days .. "d ";
                    end
                    timeString = timeString .. hours .. ":" .. minutes;
                    -- ausgabe im Log für Debug
                    -- print(outputItem.Fabrik .. " braucht " .. outputItem.NeedsItem .. " in " .. timeString .. " Stunden. Platz für " .. math.floor(outputItem.NeedsAmount));
                    if (lineCount < maxLines) then
                        lineCount = lineCount+1;
                        posY = posY - textSize;
                        if (days == 0) then
                            setTextColor(1,0.65,0,1);		
                            setTextBold(false);
                        else
                            setTextColor(1,1,1,1);		
                            setTextBold(false);
                        end	
                        local textLine = (outputItem.Fabrik .. " | " .. outputItem.NeedsItem .. " | " .. timeString .. " | " .. math.floor(outputItem.NeedsAmount));
                        totalTextHeigh = totalTextHeigh + getTextHeight(textSize, textLine)
                        local textWidth = getTextWidth(textSize, textLine);
                        if (textWidth > maxTextWidth) then maxTextWidth = textWidth; end
                        renderText(posX,posY,textSize,textLine);
                    else
                       additionalCounter = additionalCounter + 1;
                    end
                end
            end
        end
    end
        
    if (additionalCounter > 0) then
        posY = posY - textSize;
        local textLine = (additionalCounter .. " weitere");
        setTextColor(1,1,1,1);								
        setTextBold(false);
        totalTextHeigh = totalTextHeigh + getTextHeight(textSize, textLine)
        local textWidth = getTextWidth(textSize, textLine);
        if (textWidth > maxTextWidth) then maxTextWidth = textWidth; end
        renderText(posX,posY,textSize,textLine);
    end


    local maxSellPriceLines = 10;
    local lineCountSellPrices = 0;
    additionalCounter = 0;
    if GC_ProductionInfoHud.sellPriceData ~= nil and (GC_ProductionInfoHud.settings["display"]["showType"] == "ALL" or string.find(GC_ProductionInfoHud.settings["display"]["showType"], "SELLPRICE")) then
        for a, sellPriceItem in pairs (GC_ProductionInfoHud.sellPriceData) do
            for b, sellPriceStorage in pairs (sellPriceItem.storages) do
                if sellPriceStorage.fillLevel >= 200000 then
                    if (lineCountSellPrices <= maxSellPriceLines) and (sellPriceItem.info.station ~= "Brueckenbau") then
                        if (lineCountSellPrices == 0) then
                            posY = posY - textSize;
                            setTextColor(1,1,1,1);	
                            renderText(posX,posY,textSize,"PriceInfo: ");
                        totalTextHeigh = totalTextHeigh + getTextHeight(textSize, "PriceInfo: ")
                        end
                        lineCountSellPrices = lineCountSellPrices+1;
                        posY = posY - textSize;
                        local textLine = (b .. " -> " .. sellPriceItem.info.station .. " | " .. sellPriceItem.info.title .. " (" .. math.floor(sellPriceStorage.fillLevel) .. ")");
                        setTextColor(1,1,1,1);		
                        setTextBold(false);
                        totalTextHeigh = totalTextHeigh + getTextHeight(textSize, textLine)
                        local textWidth = getTextWidth(textSize, textLine);
                        if (textWidth > maxTextWidth) then maxTextWidth = textWidth; end
                        renderText(posX,posY,textSize,textLine);
                        --renderText(posX + getTextWidth(textSize, textLine),posY,textSize, "Test");
                    else
                       additionalCounter = additionalCounter + 1;
                    end
                end
            end
        end
    end
        
    if (additionalCounter > 0) then
        posY = posY - textSize;
        local textLine = (additionalCounter .. " weitere");
        setTextColor(1,1,1,1);								
        setTextBold(false);
        totalTextHeigh = totalTextHeigh + getTextHeight(textSize, textLine)
        local textWidth = getTextWidth(textSize, textLine);
        if (textWidth > maxTextWidth) then maxTextWidth = textWidth; end
        renderText(posX,posY,textSize,textLine);
    end


--print("posY: "..posY);
--print("totalTextHeigh: "..totalTextHeigh);
--print("posYStart: "..posYStart);
--print("y: "..(posYStart - totalTextHeigh + textSize));
    setOverlayColor(GC_ProductionInfoHud.overlay.overlayId, 0, 0, 0, 0.5);
	setOverlayUVs(GC_ProductionInfoHud.overlay.overlayId, 0.0078125,0.990234375, 0.0078125,0.9921875, 0.009765625,0.990234375, 0.009765625,0.9921875);
	GC_ProductionInfoHud.overlay:setPosition(posX-0.001, posYStart - totalTextHeigh - 0.002);
	GC_ProductionInfoHud.overlay:setDimension(maxTextWidth+0.002, totalTextHeigh);
	GC_ProductionInfoHud.overlay:render();
    
end;

function GC_ProductionInfoHud:refreshOutputTable()

    local usageList = {};
    
    for i, globalFactory in pairs (g_company.loadedFactories) do
        -- output for debugging
--        print(i.." : "..globalFactory.indexName);
--        if(globalFactory.indexName == "DUENGER") then
--            tprint(globalFactory);
--        end

        if (globalFactory.customEnvironment ~= "FS19_FEDmods_Ballenlager") and (globalFactory.customEnvironment ~= "FS19_AgrarSiloKDS_GC") and (globalFactory.indexName ~= "Einkauf") and (globalFactory.indexName ~= "Brueckenbau") then
            local usageItem = {};
            usageList[i] = {};	
            usageList[i].indexName = globalFactory.indexName;
            usageList[i].GuiName = globalFactory.guiData.factoryTitle;
            usageList[i].UsageItem = usageItem;

            for a, b in pairs (globalFactory.inputProducts) do
                usageItem[a] = {};	
                usageItem[a].Name = b.concatedFillTypeTitles;
                usageItem[a].capacity = b.capacity;
                usageItem[a].fillLevel = b.fillLevel;
                usageItem[a].id = b.id;
                usageItem[a].usagePerHour = 0;
                usageItem[a].HoursLeft = 0;
                usageItem[a].UseCount = 0;

                for c, d in pairs (globalFactory.productLines) do

                    if (d.userStopped == false and d.autoStart == true) then
                        -- the key for inputPercent is the key for the inputs and in the inputs there is the id to use with b.id
                        for e, f in pairs (d.inputs) do
                            if (f.id == b.id) then
                                if d.inputsPercent[e] ~= nil then
                                    local usagePerHour = d.outputPerHour * d.inputsPercent[e];
                                    usageItem[a].usagePerHour = usageItem[a].usagePerHour+usagePerHour;
                                    usageItem[a].UseCount = usageItem[a].UseCount + 1;
                                end
                            end
                        end
                    end
                end
                if (usageItem[a].fillLevel ~= 0) and (usageItem[a].usagePerHour ~= 0) then
                    usageItem[a].HoursLeft = usageItem[a].fillLevel / usageItem[a].usagePerHour;
                end

            end
        end
    end;

--    print("usageList : ");
--    tprint(usageList);

    -- sortieren und auf dem Schirm ausgeben, aber wie sortieren? Restzeit als Key wird nicht gehen, da gleiche Zahlen mehrmals vorkommen können
    -- Liste erstelle pro Item und Usage zum sortieren und ausgeben
    local outputTable = {};
    for a, usageGroup in pairs (usageList) do
        for c, usageItem in pairs (usageGroup.UsageItem) do
            local percentageFilled = usageItem.fillLevel/usageItem.capacity;
            if (usageItem.UseCount ~= 0 and percentageFilled <= 0.75) then
                local outputItem = {};
                outputItem.Fabrik = usageGroup.GuiName;
                outputItem.NeedsItem = usageItem.Name;
                outputItem.HoursLeft = usageItem.HoursLeft;
                outputItem.NeedsAmount = usageItem.capacity-usageItem.fillLevel;
                table.insert(outputTable , outputItem)
            end
        end
    end

    table.sort(outputTable,comp)

--    print("outputTable : ");
--    tprint(outputTable);
    GC_ProductionInfoHud.outputTable = outputTable;
end;

-- Zum Sortieren der Ausgabeliste nach Zeit
function comp(w1,w2)
    if w1.HoursLeft < w2.HoursLeft then
        return true
    end
end

-- Hilfsfunktion um sich eine table im Log an zu schauen
function tprint (tbl, indent)
  if not indent then indent = 0 end
  for k, v in pairs(tbl) do
    formatting = string.rep("  ", indent) .. k .. ": "
    if k == "target" or k == "visibilityNodes" or k == "source" or k == "parent" or k == "productionFactories" or k == "movers" or k == "digitalDisplays" or k == "debugData" or k == "operateVisibility" or k == "operateSounds" or k == "playerTrigger" then
      --print(formatting .. "Skipped")      
    elseif type(v) == "table" then
      print(formatting)
      tprint(v, indent+1)
    elseif type(v) == 'boolean' then
      print(formatting .. tostring(v))   
    elseif type(v) == 'function' then
      --print(formatting .. "function " ..tostring(v))   
    else
      print(formatting .. v)
    end
  end
end
